"use strict";
Object.defineProperty(exports, "useColumnView", {
    enumerable: true,
    get: ()=>useColumnView
});
const _react = require("react");
const _redux = require("./redux");
const _buildInitialState = require("./utils/buildInitialState");
const _createItemsProps = require("./utils/createItemsProps");
const useColumnView = (options)=>{
    const stateReducer = (0, _react.useMemo)(()=>(0, _redux.createReducer)(), []);
    var _options_initialState;
    const [{ root , data , path  }, dispatch] = (0, _react.useReducer)(stateReducer, (_options_initialState = options == null ? void 0 : options.initialState) != null ? _options_initialState : [], _buildInitialState.buildInitialState);
    const selectNode = (0, _react.useCallback)((id)=>{
        const node = data[id];
        if (!node) {
            return;
        }
        dispatch({
            type: 'select',
            item: node
        });
    }, [
        data,
        dispatch
    ]);
    const insert = (0, _react.useCallback)((item, parentId)=>dispatch({
            type: 'insert',
            item,
            parentId
        }), [
        dispatch
    ]);
    const push = (0, _react.useCallback)((item, section)=>dispatch({
            type: 'push',
            item,
            section
        }), [
        dispatch
    ]);
    return {
        root: (0, _createItemsProps.createItemsProps)(root, {
            push,
            path,
            data
        }),
        path: (0, _createItemsProps.createItemsProps)(path, {
            push,
            path,
            data
        }),
        insert,
        selectNode,
        data
    };
};

//# sourceMappingURL=index.js.map